#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.2"

#define IN  0x0001
#define OUT 0x0002
#define STAYOUT 0x0008

new Handle:Cvar_FtbDelay = INVALID_HANDLE
new Handle:Cvar_FtbSPEC = INVALID_HANDLE

public Plugin:myinfo = 
{
	name = "DoDS Fade to Black",
	author = "<eVa>Dog, Darkranger",
	description = "Fade to Black & Black Screen for Spectator",
	version = PLUGIN_VERSION,
	url = "http://dodsplugins.com"
}

public OnPluginStart()
{
	CreateConVar("sm_dod_ftb_version", PLUGIN_VERSION, "Version of sm_dod_ftb", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)
	Cvar_FtbDelay = CreateConVar("sv_dod_ftb_delay", "0", " The duration of the Fade to Black screen fade! 0 = disabled", FCVAR_PLUGIN)
	Cvar_FtbSPEC = CreateConVar("sv_dod_ftb_spec", "1", " Black Screen for Spectator! 1 = Enabled; 0 = disabled", FCVAR_PLUGIN)
	HookEvent("player_death", PlayerDeathEvent)
	HookEvent("player_team", OnPlayerTeam)
	HookEvent("dod_round_start", Event_round_start)
}

public OnEventShutdown()
{
	UnhookEvent("player_death", PlayerDeathEvent)
	UnhookEvent("player_team", OnPlayerTeam)
	UnhookEvent("dod_round_start", Event_round_start)
}


public PlayerDeathEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(Cvar_FtbDelay) > 0)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"))
		ScreenFade(client, 0, 0, 0, 255, GetConVarInt(Cvar_FtbDelay), OUT)
	}
}

public Action:OnPlayerTeam(Handle:event,const String:name[],bool:dontBroadcast)
{
	if (GetConVarInt(Cvar_FtbSPEC) == 1)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		if(!client || IsFakeClient(client))
		{
			return;
		}
		new team = GetEventInt(event,"team");
		if(team == 1)
		{
			ScreenFadeSPEC(client, 0, 0, 0, 255, 10000, STAYOUT)
			PrintToChat(client, "AS SPECTATOR IT IS NOT ALLOWED TO SEE THE ACTION")
			PrintHintText(client, "AS SPECTATOR IT IS NOT ALLOWED TO SEE THE ACTION")
			PrintCenterText(client, "AS SPECTATOR IT IS NOT ALLOWED TO SEE THE ACTION")
		}
		return;
	}
}

public Event_round_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(Cvar_FtbSPEC) == 1)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i))
			{
				new team = GetClientTeam(i);
				if(team == 1)
				{
					CreateTimer(4.0, ScreenFadeRoundStart ,i);
				}
			}
		}
	}
}

public Action:ScreenFadeRoundStart(Handle:timer, any:client)
{
	if(IsValidClient(client))
	ScreenFadeSPEC(client, 0, 0, 0, 255, 10000, STAYOUT)
	PrintToChat(client, "AS SPECTATOR YOU ARE NOT ALLOWED TO SEE THE ACTION")
	PrintHintText(client, "AS SPECTATOR YOU ARE NOT ALLOWED TO SEE THE ACTION")
	PrintCenterText(client, "AS SPECTATOR YOU ARE NOT ALLOWED TO SEE THE ACTION")
}


public IsValidClient( client )
{
    if ( !( 1 <= client <= MaxClients ) || !IsClientInGame(client) )
        return false;

    return true;
}

//Fade the screen
public ScreenFade(client, red, green, blue, alpha, delay, type)
{
	new Handle:msg
	new duration
	duration = delay * 1000
	msg = StartMessageOne("Fade", client)
	BfWriteShort(msg, 500)
	BfWriteShort(msg, duration)
	BfWriteShort(msg, type)
	BfWriteByte(msg, red)
	BfWriteByte(msg, green)
	BfWriteByte(msg, blue)	
	BfWriteByte(msg, alpha)
	EndMessage()
}

//Fade the screen for Spectator
public ScreenFadeSPEC(client, red, green, blue, alpha, duration, type)
{
	new Handle:msg
	msg = StartMessageOne("Fade", client)
	BfWriteShort(msg, 1500)
	BfWriteShort(msg, duration)
	BfWriteShort(msg, type)
	BfWriteByte(msg, red)
	BfWriteByte(msg, green)
	BfWriteByte(msg, blue)	
	BfWriteByte(msg, alpha)
	EndMessage()
}